/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3935_CDPFUNO_CALCULA_CUSTO_SOBRA.SQL

Descrio:
Funo para retornar o custo do produto produzido a parte na ordem de produo consolidada

Criao:
01/08/2007 Welbert Gonalves Moitinha
*/

CREATE OR REPLACE FUNCTION CALCULA_CUSTO_SOBRA (
        P_CDFILIAL     IN ORDPRODUCAO.CDFILIAL%TYPE,
        P_NRORDPROD    IN ORDPRODUCAO.NRORDPROD%TYPE,
        P_NRSUBORDPROD IN ORDPRODUCAO.NRSUBORDPROD%TYPE,
        P_CDPRODSOBRA  IN PRODUTO.CDARVPROD%TYPE,
        P_CDMATPRIMA   IN PRODUTO.CDARVPROD%TYPE,
        P_NRTIPOCUSTO  IN NUMBER
) RETURN FLOAT
AS

   V_CDMATPRIMA   PRODUTO.CDPRODUTO%TYPE;
   V_IDRATCUSPROD PARPRODOPCONS.IDRATCUSPROD%TYPE;
   V_VRPERCUSMAT  PARPRODOPCONS.VRPERCUSMAT%TYPE;
   V_CUSTOPROD    FLOAT;
   V_CUSTOTOTAL   FLOAT;
   V_CDPRODPERDA  PRODUTO.CDPRODUTO%TYPE;
BEGIN
   V_CUSTOTOTAL := 0;


   BEGIN
      SELECT CDPRODUTO
      INTO V_CDPRODPERDA
      FROM PRODUTO
      WHERE
         CDARVPROD = P_CDPRODSOBRA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDPRODPERDA := '';
   END;


   BEGIN
      SELECT CDPRODUTO
      INTO V_CDMATPRIMA
      FROM PRODUTO
      WHERE
         CDARVPROD = P_CDMATPRIMA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDMATPRIMA := '';
   END;

   IF NOT V_CDMATPRIMA IS NULL THEN

      SELECT
         SUM(ROUND(CUSTO_PRODUTO_LCEST(P_CDFILIAL, I.CDPRODUTO, P_NRTIPOCUSTO, SYSDATE, SYSDATE, L.CDALMOXARIFE, L.CDLOCALESTOQ,
                                                      L.NRLOTEESTQ, L.NRSUBLOTE), 5) * I.QTPRERETPROD) / SUM(I.QTPRERETPROD)
      INTO
         V_CUSTOPROD
      FROM
         RETIRADAESTO R, ITEMRETIEST I, LOTITRETIEST L
      WHERE
         I.CDFILIAL     = P_CDFILIAL    AND
         R.NRORDPROD    = P_NRORDPROD    AND
         R.NRSUBORDPROD = P_NRSUBORDPROD AND
         I.CDPRODUTO    = V_CDMATPRIMA AND
         I.CDFILIAL     = R.CDFILIAL AND
         I.NRRETEST     = R.NRRETEST AND
         I.CDFILIAL     = L.CDFILIAL AND
         I.NRRETEST     = L.NRRETEST AND
         I.CDPRODUTO    = L.CDPRODUTO AND
         L.IDTPRETEST   = 'R';

      SELECT
         IDRATCUSPROD,
         VRPERCUSMAT
      INTO
         V_IDRATCUSPROD, V_VRPERCUSMAT
      FROM PARPRODOPCONS
      WHERE
          CDFILIAL   = P_CDFILIAL AND
          CDMATPRIMA = V_CDMATPRIMA AND
          CDPRODUTO  = V_CDPRODPERDA;


      IF V_IDRATCUSPROD = 'N' THEN
         V_CUSTOTOTAL := V_CUSTOPROD * (V_VRPERCUSMAT/100);
      ELSE
         V_CUSTOTOTAL := V_CUSTOPROD;
      END IF;

   END IF;

 RETURN(V_CUSTOTOTAL);

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CALCULA_CUSTO_SOBRA','4.11.159'); END;
/


